var h = Object.defineProperty;
var p = (n, e, t) => e in n ? h(n, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : n[e] = t;
var u = (n, e, t) => (p(n, typeof e != "symbol" ? e + "" : e, t), t);
import { ViewPlugin as f, Decoration as r, keymap as S, WidgetType as y } from "@codemirror/view";
import { StateField as C, StateEffect as F, Facet as k, Prec as x, EditorSelection as l } from "@codemirror/state";
import { debouncePromise as P } from "./lib/utils.js";
const a = C.define({
  create() {
    return { suggestion: null };
  },
  update(n, e) {
    const t = e.effects.find(
      (s) => s.is(d)
    );
    return e.state.doc && t && e.state.doc == t.value.doc ? { suggestion: t.value.text } : { suggestion: null };
  }
}), d = F.define();
function D(n, e) {
  const t = n.state.selection.main.head, s = [], o = r.widget({
    widget: new E(e),
    side: 1
  });
  return s.push(o.range(t)), r.set(s);
}
const g = k.define({
  combine(n) {
    var e, t;
    return {
      acceptOnClick: !!((e = n.at(-1)) != null && e.acceptOnClick),
      fetchFn: (t = n.at(-1)) == null ? void 0 : t.fetchFn
    };
  }
});
class E extends y {
  /**
   * Create a new suggestion widget.
   */
  constructor(t) {
    super();
    u(this, "suggestion");
    this.suggestion = t;
  }
  toDOM(t) {
    const s = document.createElement("span");
    return s.style.opacity = "0.4", s.className = "cm-inline-suggestion", s.textContent = this.suggestion, s.onclick = (o) => this.accept(o, t), s;
  }
  accept(t, s) {
    var c;
    if (!s.state.facet(g).acceptOnClick)
      return;
    t.stopPropagation(), t.preventDefault();
    const i = (c = s.state.field(a)) == null ? void 0 : c.suggestion;
    return i ? (s.dispatch({
      ...m(
        s.state,
        i,
        s.state.selection.main.head,
        s.state.selection.main.head
      )
    }), !0) : !1;
  }
}
const T = f.fromClass(
  class {
    async update(e) {
      const t = e.state.doc;
      if (!e.docChanged || e.transactions.some(
        (c) => c.isUserEvent("input.complete")
      ))
        return;
      const o = e.view.state.facet(g);
      if (!o.fetchFn) {
        console.error(
          "Unexpected issue in codemirror-copilot: fetchFn was not configured"
        );
        return;
      }
      const i = await o.fetchFn(e.state);
      e.view.dispatch({
        effects: d.of({ text: i, doc: t })
      });
    }
  }
), O = f.fromClass(
  class {
    constructor() {
      u(this, "decorations");
      this.decorations = r.none;
    }
    update(e) {
      var s;
      const t = (s = e.state.field(a)) == null ? void 0 : s.suggestion;
      if (!t) {
        this.decorations = r.none;
        return;
      }
      this.decorations = D(
        e.view,
        t
      );
    }
  },
  {
    decorations: (n) => n.decorations
  }
), I = x.highest(
  S.of([
    {
      key: "Tab",
      run: (n) => {
        var t;
        const e = (t = n.state.field(a)) == null ? void 0 : t.suggestion;
        return e ? (n.dispatch({
          ...m(
            n.state,
            e,
            n.state.selection.main.head,
            n.state.selection.main.head
          )
        }), !0) : !1;
      }
    }
  ])
);
function m(n, e, t, s) {
  return {
    ...n.changeByRange((o) => {
      if (o == n.selection.main)
        return {
          changes: { from: t, to: s, insert: e },
          range: l.cursor(t + e.length)
        };
      const i = s - t;
      return !o.empty || i && n.sliceDoc(o.from - i, o.from) != n.sliceDoc(t, s) ? { range: o } : {
        changes: { from: o.from - i, to: o.from, insert: e },
        range: l.cursor(o.from - i + e.length)
      };
    }),
    userEvent: "input.complete"
  };
}
function B(n) {
  const { delay: e = 500, acceptOnClick: t = !0 } = n, s = P(n.fetchFn, e);
  return [
    g.of({ acceptOnClick: t, fetchFn: s }),
    a,
    T,
    O,
    I
  ];
}
export {
  T as fetchSuggestion,
  B as inlineSuggestion,
  g as suggestionConfigFacet
};
//# sourceMappingURL=inline-suggestion.js.map
